/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;
import de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftUK;

public abstract class AbstractGebietsarteigenschaftDAO extends de.ivu.elect.jee.entity.AbstractDAO<Gebietsarteigenschaft,
        de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
    , GebietsarteigenschaftUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractGebietsarteigenschaftDAO.class);

  public AbstractGebietsarteigenschaftDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Gebietsarteigenschaft findByPrimaryKey(
        de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Gebietsarteigenschaft findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Gebietsarteigenschaft.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsarteigenschaft o WHERE o.wahlart.mandant=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.All")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAll - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByAll - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from Gebietsarteigenschaft o where o.gebietsart=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.Gebietsart")
                              .setParameter(1, gebietsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByGebietsart - NonUniqueResultException, Parameter: "
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: InMandantVerwendetNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsarteigenschaft o WHERE EXISTS (SELECT w From Wahl w WHERE o.wahlart = w.wahlart AND w.wahltermin.mandant=?1 AND EXISTS (SELECT g FROM Gebiet g WHERE g.gebietsart = o.gebietsart AND g.wahl = w))<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByInMandantVerwendet( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.InMandantVerwendet")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByInMandantVerwendet - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByInMandantVerwendet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartAndErfassungsgebietEagerGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsarteigenschaft o JOIN FETCH o.gebietsart WHERE o.wahlart=?1 AND o.erfassungsgebiet=?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByWahlartAndErfassungsgebietEagerGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull java.lang.Boolean isErfassungsgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  java.lang.Boolean isErfassungsgebietCheckedAndAttached =  isErfassungsgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.WahlartAndErfassungsgebietEagerGebietsart")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, isErfassungsgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlartAndErfassungsgebietEagerGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByWahlartAndErfassungsgebietEagerGebietsart - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", isErfassungsgebiet:'"+isErfassungsgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartAndErfassungsgebietEagerGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from Gebietsarteigenschaft o where o.wahlart=?1 and o.gebietsart=?2<br>
      * SQL: <br>
      */
     public Gebietsarteigenschaft findByWahlartAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (Gebietsarteigenschaft)
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.WahlartAndGebietsart")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlartAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByWahlartAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartBeiAufteilungNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsarteigenschaft o WHERE o.wahlartBeiAufteilung=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByWahlartBeiAufteilung( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.WahlartBeiAufteilung")
                              .setParameter(1, wahlartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByWahlartBeiAufteilung - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartBeiAufteilung(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsarteigenschaft o WHERE o.wahlart=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsarteigenschaft> findByWahlart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSARTEIGENSCHAFT.Wahlart")
                              .setParameter(1, wahlartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsarteigenschaft, findByWahlart - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftUK uk,
        de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft findByUK(de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftUK uk){

    try {
     return (de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft) getEntityManager().createNamedQuery("GEBIETSARTEIGENSCHAFT.UK")
                  .setParameter(1, uk
                .getGebietsartUK ()

                .getName ()

              )
             .setParameter(2, uk
                .getGebietsartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(3, uk
                .getWahlartUK ()

                .getName ()

              )
             .setParameter(4, uk
                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Gebietsarteigenschaft, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}